<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/

// Funktion um die regExps aus der Datenbank wieder in "schoene" Masken zu verwandeln
function regexp2mask($regexp) {
	$mask = str_replace(array(	'.?',
								'.*'),
						array(	'?',
								'*'),
						stripslashes($regexp));
	return substr($mask, 1, -1);
}

if (!isset($_SESSION['bot'])) {
	echo "<p>Erst einen Bot ausw&auml;hlen.</p>\n";
} else {
	
	// Neue Benutzerrechte einfuegen
	if (isset($_GET['uaid'])) {
		$db->insert('user_access_bot', array('user_access_id' => intval($_GET['uaid']), 'bot_id' => $_SESSION['bot']));
	}
	
	if (isset($_POST['uaid'])) {
		if ($_POST['status'] === '-1') {
			// Deinstallieren eines Benutzerrechtes
			$db->query('DELETE FROM user_access_bot WHERE user_access_id = ' . intval($_POST['uaid']) . ' AND bot_id = ' . $_SESSION['bot']);
		} else {
			// Update (Aendern) eines Benutzerrechtes
			$db->update('user_access_bot', array('level' => $_POST['status']) , 'user_access_id = ' . intval($_POST['uaid']) . ' AND bot_id = ' . $_SESSION['bot']);
		}
	}

	// Farb- und und Transformationsarrays fuer die Status
	$status = array(-1 => 'uninstall', 0 => 'none', 1 => 'voice', 2 => 'halfop', 4 => 'op', 8 => 'admin', 16 => 'founder');
	$color = array(-1 => '#FF0000', 0 => '#000000', 1 => '#00FF00', 2 => '#42C000', 4 => '#818100', 8 => '#C04200', 16 => '#FF0000');

	// Ausgabe
	if ($db->query('SELECT ua.id, ua.mask, uab.level FROM user_access AS ua LEFT JOIN user_access_bot AS uab ON uab.bot_id = ' . $_SESSION['bot'] . ' AND uab.user_access_id = ua.id ORDER BY uab.level DESC')) {
		echo "<table>\n";
		echo "<tr><th>Mask</th><th>Level</th></td>\n";
		while ($db->isNext()) {
			$row = $db->getNext();
			printf("<tr><td>%s</td>", regexp2mask($row['mask']));
			if ($row['level'] === NULL) {
				printf("<td style=\"text-align: center;\"><a href=\"%s&amp;uaid=%s\">[install]</a></td>",
						$self,
						$row['id']);
			} else {
					echo "\t<td style=\"text-align: center;\">\n";
					echo "\t\t<form action=\"$self\" method=\"post\">\n";
					echo "\t\t\t<input type=\"hidden\" name=\"uaid\" value=\"${row['id']}\" />\n";
					echo "\t\t\t<select name=\"status\" style=\"color: " . $color[(int) $row['level']] . ";\">\n";
					foreach ($status as $lvl => $name) {
						printf("\t\t\t\t<option value=\"%d\" style=\"color: %s;\" %s>%s</option>\n",
								$lvl,
								$color[$lvl],
								($lvl == (int) $row['level'] ? 'selected' : ''),
								$name);
					}
					echo "\t\t\t</select>\n";
					echo "\t\t\t<input type=\"submit\" name=\"form\" value=\"go\" style=\"\" />\n";
					echo "\t\t</form>\n";
					echo "\t</td>\n";
			}
			echo "</tr>\n";
		}
		echo "</table>\n";
	} else {
		echo "<p>Bisher keine Benutzer eingef&uuml;gt.</p>\n";
	}
	
}

?>