<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/

if (!empty($_POST)) {
	// Neues Modul installieren
	$file = file($_POST['address'] . '?install');
	
	if (empty($file)) {
		echo "<p>Kein Modul unter angegebener Adresse zu finden.</p>\n";
	} else {
		// Informationen zu dem Modul einholen
		$module = array();
		foreach ($file as $line) {
			if (preg_match('/^\s*(command|action|text)\s*:?\s*([#\w\d\[\]\\`^\{\}_-]*)\s*(\((.*?)\))?\s*$/i', $line, $match)) {
				$module['type'][] = strtolower($match[1]);
				$module['command'][] = strtolower($match[2]);
				$module['description'][] = $match[4];
			}
		}
		
		// Kommandos in die Datenbank einfuegen
		$module_id = $db->insert('module', array('address' => $_POST['address']));
		for ($i = 0; $i < count($module['type']); $i++) {
			$db->insert('command', array('module_id' =>	$module_id,
											'type' =>		$module['type'][$i],
											'command' =>	$module['command'][$i],
											'descr' =>		$module['description'][$i]));
		}
	}
}

if (isset($_GET['action'])) {
	$id = intval($_GET['mid']);
	switch (strtolower($_GET['action'])) {
		case 'delete':
			// Loeschen eines Modules
			$db->query('DELETE FROM module WHERE id = ' . $id);
			
			// Die ID's aller Modulcommandos holen
			$commands = array();
			$db->query('SELECT id FROM command WHERE module_id = ' . $id);
			while ($db->isNext()) $commands[] = (int) @reset($db->getNext());
			
			// Loeschen aller Zugriffsrechte
			$db->query('DELETE FROM access WHERE command_id IN (' . implode(', ', $commands) . ')');
			// Loeschen aller Commandos des Modules
			$db->query('DELETE FROM command WHERE module_id = ' . $id);
		break;
		case 'refresh':
			// Aktualisieren der Moduldaten
		break;
	}
}

// Ausgabe
if ($db->query('SELECT m.id, m.address, IFNULL(COUNT(c.id), 0) AS commands FROM module AS m LEFT JOIN command AS c ON c.module_id = m.id GROUP BY m.id ORDER BY address')) {
	echo "<table>\n";
	echo "<tr><th>Adresse</th><th>Kommandos</th><th>Optionen</th></tr>\n";
	while ($db->isNext()) {
		$row = $db->getNext();
		printf("<tr><td>%s</td><td>%s</td><td>[ <a href=\"%s&amp;action=delete&amp;mid=%s\">delete</a> | <a href=\"%s&amp;action=refresh&amp;id=%s\">refresh</a> ]</td></tr>\n", 
				$row['address'],
				$row['commands'],
				$self,
				$row['id'],
				$self,
				$row['id']);
	}
	echo "</table>\n";
} else {
	echo "<p>Keine Module installiert.</p>";
}

// Formular
echo "<form action=\"" . $self . "\" method=\"POST\">\n";
echo "<p>Ein neues Modul installieren: <input type=\"text\" name=\"address\" />.</p>\n";
echo "<button type=\"submit\" style=\"display: none;\" />\n";
echo "</form>\n";

?>