<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/

/**
 * Simple, veraltete PHP4-Klasse fuer die Seitengenerierung
 *
 * Findet nur noch Verwendung in der Bot-Web-Adminstration
 */
 
function scroll (
$anzahl,
$offset = 0,
$perPage = 10,
$link = '') {
	// Werte eventuell korrigieren
	$perPage = intval(abs($perPage));
	$pages = max(1, ceil($anzahl / $perPage));
	$aktPage = @max(0, min($pages, floor($offset / $perPage)));
	
	$return = 'Seite: ';
	for ($i = 0; $i < $pages; $i++) {
		if ($i == $aktPage) {
			$return .= '<span class=\"bold\">(' . ($i + 1) . ')</span> - ';
		} else {
			$return .= '<a href="' . $link . '&amp;offset=' . ($i * $perPage) . '">' . ($i + 1) . '</a> - ';
		}
	}
	return substr($return, 0, -3) . '<br />';
}

class navigation {
	
	var $kat;
	var $site;
	var $db;
	var $tpl;
	
	function navigation (
	) {
		$this->load('template.php');
		$this->load('../../classes/mysql.php');
		
		$this->initClasses();
		
		$this->kat = array(0 => false);
		$this->site = array(0 => array(0 => false));
	}
	
	function load(
	$class
	) {
		$path = dirname(__FILE__) . '/' . basename($class);
		if (!is_file($path) || !is_readable($path)) die('Kann benoetigte Datei ' . $path . ' nicht laden.');
		return @require_once($path);
	}
	
	function initClasses (
	) {
		$this->db = new mysql();
		
		$this->tpl = new template();
		$this->tpl->parseFile('data/main.tpl');
	}
	
	function addMain (
	$name,
	$include,
	$comment = '',
	$icon = ''
	) {
		$nbr = array_push(	$this->kat,
							array(	'name'		=>	$name,
									'include'	=>	$include,
									'comment'	=>	$comment,
									'icon'		=>	'icons/' . (empty($icon) ? 'blank.png' : $icon))) - 1;
		$this->site[$nbr] = array(0 => false);
		return $nbr;
	}
	
	function addSub(
	$nr,
	$name,
	$include,
	$comment = '',
	$icon = '',
	$exec = ''
	) {
		$this->site[$nr][] = array(	'name'		=> $name,
									'include'	=> $include,
									'exec'		=> $exec,
									'comment'	=> $comment,
									'icon'		=> 'icons/' . (empty($icon) ? 'blank.png' : $icon));
	}
	
	function output(
	$kat = 0,
	$site = 0
	) {
		$kat = min(max(1,intval($kat)), max(array_keys($this->kat)));
		$site = intval($site);
		
		$nav = '';
		for ($i = 1; $i < count($this->kat); $i++) {
			$nav .= sprintf(	"\t\t</div>\n\n\t\t<div class=\"cat\">\n\t\t\t<div class=\"cat_icon\">\n\t\t\t\t<img class=\"icon\" src=\"%s\" alt=\"%s\" />\n\t\t\t</div>\n\t\t\t<a class=\"cat_link\" href=\"%s\" title=\"%s\">%s</a>\n",
								$this->kat[$i]['icon'],
								$this->kat[$i]['name'],
								'index.php?kat=' . $i,
								$this->kat[$i]['comment'],
								$this->kat[$i]['name']);
			if ($i == $kat) {
				for ($j = 1; $j < count($this->site[$i]); $j++) {
					$nav .= sprintf(	"\t\t\t<div class=\"site\">\n\t\t\t\t<div class=\"site_icon\">\n\t\t\t\t\t<img class=\"icon\" src=\"%s\" alt=\"%s\" />\n\t\t\t\t</div>\n\t\t\t\t<a class=\"site_link\" href=\"%s\" title=\"%s\">%s</a>\n\t\t\t</div>\n",
										$this->site[$i][$j]['icon'],
										$this->site[$i][$j]['name'],
										'index.php?kat=' . $i . '&amp;site=' . $j,
										$this->site[$i][$j]['comment'],
										$this->site[$i][$j]['name']);					
				}
			}
		}
		
		if ($this->kat[$kat]) {
			if ($this->site[$kat][$site]) {
				$file = $this->site[$kat][$site]['include'];
				$title = $this->site[$kat][$site]['name'];
			} else {
				$file = $this->kat[$kat]['include'];
				$title = $this->kat[$kat]['name'];
			}
			
			ob_start();
			if (is_file($file) && is_readable($file)) {
				$db = &$this->db;
				$self = 'index.php?kat=' . $kat . '&amp;site=' . $site;
				include($file);
			}
			$main = ob_get_contents();
			ob_end_clean();
		} else {
			$main = '';
		}
		
		$this->tpl->assign('nav',	$nav);
		$this->tpl->assign('text',	$main);
		$this->tpl->assign('title',	$title);
		
		return $this->tpl->getOutput();
	}
	
	function additional(
	$kat = 0,
	$site = 0
	) {
		$kat = min(max(1,intval($kat)), max(array_keys($this->kat)));
		$site = intval($site);
		
		$file = $this->site[$kat][$site]['exec'];
		if (!empty($file) && is_file($file) && is_readable($file)) {
			set_time_limit(0);
			ob_implicit_flush(true);
			$db = &$this->db;
			include($file);
		} else {
			return false;
		}
	}
}

?>