<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/

/**
 * Simple, veraltete PHP4-Templateklasse
 *
 * Findet nur noch Verwendung in der Bot-Web.Adminstration
 */
 
class tplElement {
	
	var $replace;
	var $name;
	var $options;
	var $replacement;
	var $value;
	
	function tplElement(
	$replace,
	$name,
	$option,
	$value = ''
	) {
		$this->replace = $replace;
		$this->name = trim($name);
		$this->replacement = '';
		$this->value = $value;
		
		if (preg_match_all('/([a-z]+)\s*=\s*([\'"])(.*?)\2/ims', $option, $matches)) {
			for ($i = 0; $i < count($matches[0]); $i++) {
				$this->options[strtolower(trim($matches[1][$i]))] = trim($matches[3][$i]);
			}
		}
	}
	
	function getParams(
	) {
		return array_keys($this->options);
	}
	
	function getValue(
	$param
	) {
		$param = strtolower($param);
		
		if (!isset($this->options[$param])) {
			return false;
		} else {
			return $this->options[$param];
		}
	}
	
	function getName(
	) {
		return $this->name;
	}
	
	function getReplace(
	) {
		return $this->replace;
	}
	
	function getReplacement(
	) {
		return $this->replacement;
	}
	
	function getText(
	) {
		return $this->value;
	}
	
	function setReplacement(
	$text
	) {
		$this->replacement = $text;
	}
}

class template {
	
	var $elements;
	var $prefix;
	var $debug;
	
	var $content;
	
	function template(
	$prefix = 'tpl'
	) {
		$this->elements = array();
		$this->prefix = $prefix;
		
		$this->debug = &$debug;
	}
	
	function parseFile (
	$file
	) {
		if (!is_file($file) || !is_readable($file)) {
			$this->debug->error(CE_ERROR, $file . ' kann nicht gelesen werden.', __FILE__, __LINE__);
			return false;
		}
		
		$this->parseTemplate(file_get_contents($file));
	}
	
	function parseTemplate(
	$content
	) {
		$this->content = $content;
		
		if (preg_match_all('/<(' . $this->prefix . ':{1,2}([a-z]+))\\s*(.*?)\\s*\\/?>((.*?)<\\/\\1\s*>)?/ims', $this->content, $matches)) {
			for ($i = 0; $i < count($matches[0]); $i++) {
				$this->elements[] = new tplElement($matches[0][$i], $matches[2][$i], $matches[3][$i], $matches[5][$i]);
			}
		}
	}
	
	function &getElementsByName(
	$name
	) {
		$elements = array();
		foreach ($this->elements as $nr => $element) {
			if ($this->elements[$nr]->getName() == $name) {
				$elements[] = &$this->elements[$nr];
			}
		}
		
		return $elements;
	}
	
	function assign(
	$name,
	$value = ''
	) {
		foreach ($this->elements as $nr => $element) {
			if ($this->elements[$nr]->getName() == $name) {
				$this->elements[$nr]->setReplacement($value);
			}
		}
	}
	
	function getOutput(
	) {
		foreach ($this->elements as $nr => $element) {
			$this->content = str_replace($this->elements[$nr]->getReplace(), $this->elements[$nr]->getReplacement(), $this->content);
		}
		
		return $this->content;
	}
}

?>