<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/

/**
 * Ausgabe der dem Benutzer verfuegbaren Kommandos auf Anfrage
 */

// Installationsanweisungen
if (isset($_GET['install'])) {
	echo "command:help(Gibt eine Liste der verfuegbaren Funktionen aus.)\n";
	echo "command:hilfe(Gibt eine Liste der verfuegbaren Funktionen aus.)\n";
	die();
}

// MySQL-klasse einbinden und Objekt erstellen
require_once(dirname(__FILE__) . '/../classes/mysql.php');
$mysql = new mysql();

switch ($_GET['command']) {
	case 'help':
	case 'hilfe':
		// Pruefen, ob Hilfe zu einem bestimmten Channel angefordert wurde
		if (preg_match('/^[#&][\w\d\[\]\\\\`^\{\}_\|-]+$/', $_GET['text'])) {
			$channel = $_GET['text'];
			$_GET['text'] = '';
		} else {
			$channel = $_GET['channel'];
		}
	
		// Wenn text leer ist, eine Liste der verfuegbaren Kommandos ausgeben
		if (empty($_GET['text'])) {
			if ($mysql->query('SELECT c.command FROM command AS c, access AS a, channel AS ch WHERE ch.name = \'' . mysql_escape_string($channel) . '\' AND ch.bot_id = ' . intval($_GET['bot']) . ' AND a.channel_id = ch.id AND a.level <= ' . intval($_GET['level']) . ' AND c.id = a.command_id AND c.type = \'command\' ORDER BY c.command')) {
				
				// Kommandos in einen Array packen
				$commands = array();
				while ($mysql->isNext()) {
					$commands[] = reset($mysql->getNext());
				}
				
				// Ausgabe der "Titelzeile" abhaengig vom Ort der Anfrage
				if ($_GET['channel'] === '*') {
					echo "notice:" . $_GET['nick'] . "(Verfuegbare Kommandos im Query (!help <command> fuer naehere Informationen):)\n";
				} else {
					echo "notice:" . $_GET['nick'] . "(Verfuegbare Kommandos im Channel $channel (!help <command> fuer naehere Informationen):)\n";
				}
				
				// Ausgabe der Kommandoliste
				echo "notice:" . $_GET['nick'] . "(" . implode(', ', $commands) . ")\n";
			} else {
				echo "notice:" . $_GET['nick'] . "(Keine Kommandos in $channel verfuegbar.)\n";
			}
		} else {
			// genauere Informationen zu einem Kommando ausgeben
			if ($mysql->query('SELECT command, descr FROM command WHERE command = \'' . mysql_escape_string($_GET['text']) . "'")) {
				$row = $mysql->getNext();
				echo "notice:" . $_GET['nick'] . "(" . $row['command'] . ": " . $row['descr'] . ")\n";
			} else {
				echo "notice:" . $_GET['nick'] . "(Kommando existiert nicht.)\n";
			}
		}
	break;
}

?>
