<?php

/***
 * 
 * k.Bot - modular irc bot
 * Copyright (C) 2004 Kore Nordmann - http://www.kore-nordmann.de (German)
 * 
 * This program is free software; you can redistribute it and/or modify 
 * it under the terms of the GNU General Public License as published by 
 * the Free Software Foundation; either version 2 of the License, or (at 
 * your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but 
 * WITHOUT ANY WARRANTY; without even the implied warranty of 
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License 
 * along with this program; if not, write to the Free Software Foundation, 
 * Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307, USA. 
 * 
 * You may contact the author by mail:
 * kbot@kore-nordmann.de
 *
 * Or write to:
 * Kore Nordmann
 * Stockumer Strasse 404
 * 44227 Dortmund
 * Germany
 *
 * The latest version of k.Bot can be obtained from:
 * http://www.kore-nordmann.de/
 *
 **/

/**
 * Ausgabe der Beschreibung und Syntax von PHP-Funktionen
 */
 
// Installationsanweisungen 
if (isset($_GET['install'])) {
	echo "command:php(Gibt Syntax und Beschreibung einer PHP-Funktion aus)\n";
	echo "command:php-de(Gibt Syntax und Beschreibung einer PHP-Funktion aus)\n";
	echo "command:php-en(Syntax and description for php-functions.)\n";
	die();
}

switch ($_GET['command']) {
	case 'php':
	case 'php-de': // Ausgabe auf Deutsch
		
		// Datei holen
		$file = file_get_contents('http://de.php.net/' . urlencode($_GET['text']));
	
		// Beschreibung auslesen
		if (preg_match('/<\/h1[^>]*>[^\)]*\)(.*?)<h2[^>]*>/ims', $file, $match)) {
			$beschreibung = preg_replace('/\s+/m', ' ', strtr(strip_tags($match[1]), array_flip(get_html_translation_table(HTML_ENTITIES))));
		} else {
			$beschreibung = '';
		}
	
		// Syntax auslesen
		if (preg_match('/<\/h2[^>]*>([^\)]*\))/ims', $file, $match)) {
			$syntax = preg_replace('/\s+/m', ' ', strtr(strip_tags($match[1]), array_flip(get_html_translation_table(HTML_ENTITIES))));
		} else {
			$syntax = '';
		}
	
		if (($syntax == '') || ($beschreibung == '')) {
			// Nichts gefunden
			printf("msg:%s(Befehl nicht gefunden)\n", $_GET['output']);
		} else {
			// Ausgabe im Fall, dass etwas gefunden wurde
			printf("msg:%s(%s)\n", $_GET['output'], $beschreibung);
			printf("msg:%s(Syntax: %s)\n", $_GET['output'], $syntax);
			printf("msg:%s(Quelle: http://de.php.net/%s)\n", $_GET['output'], urlencode($_GET['text']));
		}
	break;
	case 'php-en': // Ausgabe auf Englisch
	
		// Datei holen
		$file = file_get_contents('http://www.php.net/' . urlencode($_GET['text']));
	
		// Beschreibung auslesen
		if (preg_match('/<\/h1[^>]*>[^\)]*\)(.*?)<h2[^>]*>/ims', $file, $match)) {
			$beschreibung = preg_replace('/\s+/m', ' ', strtr(strip_tags($match[1]), array_flip(get_html_translation_table(HTML_ENTITIES))));
		} else {
			$beschreibung = '';
		}
	
		// Syntax auslesen
		if (preg_match('/<\/h2[^>]*>([^\)]*\))/ims', $file, $match)) {
			$syntax = preg_replace('/\s+/m', ' ', strtr(strip_tags($match[1]), array_flip(get_html_translation_table(HTML_ENTITIES))));
		} else {
			$syntax = '';
		}
	
		if (($syntax == '') || ($beschreibung == '')) {
			// Nichts gefunden
			printf("msg:%s(Function not found)\n", $_GET['output']);
		} else {
			// Ausgaabe im Fall, dass etwas gefunden wurde
			printf("msg:%s(%s)\n", $_GET['output'], $beschreibung);
			printf("msg:%s(syntax: %s)\n", $_GET['output'], $syntax);
			printf("msg:%s(source: http://www.php.net/%s)\n", $_GET['output'], urlencode($_GET['text']));
		}
	break;
}

?>
